function Init()
    strategy:name("Opposite stop");
    strategy:description("Closes position when specified price is reached");
    
    strategy.parameters:addString("trade", "Trade", "", "");
    strategy.parameters:setFlag("trade", core.FLAG_TRADE);
    strategy.parameters:addBoolean("bidask", "Trigger price", "", false);
    strategy.parameters:setFlag("bidask", core.FLAG_BIDASK);
    strategy.parameters:addDouble("rate", "Stop level", "", 0);
end

local CanClose;

function Prepare()
    trade = instance.parameters.trade;
    local name = profile:id() .. "(" .. trade .. ")";
    instance:name(name);
    
    local trade_row = core.host:findTable("trades"):find("TradeID", trade);
    if trade_row ~= nil then
        CanClose = core.host:execute("getTradingProperty", "canCreateMarketClose", trade_row.Instrument, trade_row.AccountID);
    end
    
    ExtSubscribe(1, nil, "t1", instance.parameters.bidask, "tick");
end

function ExtUpdate(id, source, period)
    local trade_row = core.host:findTable("trades"):find("TradeID", trade);
    if trade_row == nil then
        core.host:execute("stop");
        return;
    end
    if trade_row.BS == "B" then
        if source[NOW] <= instance.parameters.rate then
            close(trade_row);
            core.host:execute("stop");
        end
    else
        if source[NOW] >= instance.parameters.rate then
            close(trade_row);
            core.host:execute("stop");
        end
    end
end

function close(trade_row)
    local valuemap = core.valuemap();
    if CanClose then
        valuemap.OrderType = "CM";
        valuemap.OfferID = trade_row.OfferID;
        valuemap.AcctID = trade_row.AccountID;
        valuemap.Quantity = trade_row.Lot;
        valuemap.TradeID = trade_row.TradeID;
        if trade_row.BS == "B" then
            valuemap.BuySell = "S";
        else
            valuemap.BuySell = "B";
        end
    else
        valuemap.OrderType = "OM";
        valuemap.OfferID = trade_row.OfferID;
        valuemap.AcctID = trade_row.AccountID;
        valuemap.Quantity = trade_row.Lot;
        if trade_row.BS == "B" then
            valuemap.BuySell = "S";
        else
            valuemap.BuySell = "B";
        end
    end
    success, msg = terminal:execute(200, valuemap);
end

function ExtAsyncOperationFinished(cookie, success, message)
end

dofile(core.app_path() .. "\\strategies\\standard\\include\\helper.lua");